-- Puffin: A Tojaso FowlPlay Project
-- Model component for maintaining spell information tables

local Model_Spells = {}
local DB = nil
local localSpells = {} -- map from local spell names to English spell names

local runeSpells = {
	["Army of the Dead"] = { blood = true, frost = true, unholy = true, id = 42650 },
	["Blood Boil"] = { blood = true, id = 48721 },
	["Blood Strike"] = { blood = true, id = 45902 },
	["Chains of Ice"] = { frost = true, id = 45524 },
	["Control Undead"] = { unholy = true, id = 111673 },
	["Dark Transformation"] = { unholy = true, id = 63560 },
	["Death and Decay"] = { unholy = true, id = 43265 },
	["Death Gate"] = { unholy = true, id = 50977 },
	["Death Strike"] = { frost = true, unholy = true, id = 49998 },
	["Festering Strike"] = { blood = true, frost = true, id = 85948 },
	["Heart Strike"] = { blood = true, id = 55050 },
	["Howling Blast"] = { frost = true, id = 49184 },
	["Icy Touch"] = { frost = true, id = 45477 },
	["Obliterate"] = { frost = true, unholy = true, id = 49020 },
	["Path of Frost"] = { frost = true, id = 3714 },
	["Pestilence"] = { blood = true, id = 50842 },
	["Pillar of Frost"] = { frost = true, id = 51271 },
	["Plague Strike"] = { unholy = true, id = 45462 },
	["Rune Tap"] = { blood = true, id = 48982 },
	["Scourge Strike"] = { unholy = true, id = 55090 },
	["Soul Reaper"] = { frost = true, id = 130735 },
	["Strangulate"] = { blood = true, id = 47476 },
}

local lockSpells = {
	["DEATHKNIGHT"] = {
		["Death Coil"] = { school = "Shadow", id = 47541 },
	},
	["DRUID"] = {
		["Rejuvenation"] = { school = "Nature", id = 774 },
	},
	["HUNTER"] = {
		["Arcane Shot"] = { school = "Arcane", id = 3044 },
		["Serpent Sting"] = { school = "Nature", id = 1978 },
	},
	["MAGE"] = {
		["Arcane Explosion"] = { school = "Arcane", id = 1449 }, 
		["Fireball"] = { school = "Fire", id = 133 }, 
		["Frostbolt"] = { school = "Frost", id = 116 }, 
		["Ice Lance"] = { school = "Frost", id = 30455 }, 
		["Molten Armor"] = { school = "Fire", id = 30482 }, 
	},
	["MONK"] = {
		["Resuscitate"] = { school = "Nature", id = 115178 }, 
		["Soothing Mist"] = { school = "Nature", id = 115175 },
	},
	["PALADIN"] = {
		["Flash of Light"] = { school = "Holy", id = 19750 },
	},
	["PRIEST"] = {
		["Shadow Word: Pain"] = { school = "Shadow", id = 589 },
		["Smite"] = { school = "Holy", id = 585 },
	},
	["ROGUE"] = {},
	["SHAMAN"] = {
		["Flametongue Weapon"] = { school = "Fire", id = 8024 },
		["Frostbrand Weapon"] = { school = "Frost", id = 8033 },
		["Lightning Bolt"] = { school = "Nature", id = 403 },
	},
	["WARLOCK"] = {
		["Incinerate"] = { school = "Fire", id = 29722 },
		["Shadow Bolt"] = { school = "Shadow", id = 686 },
		["Soul Fire"] = { school = "Fire", id = 6353 },
	 },
	["WARRIOR"] = {},
}

function Model_Spells.OnEnable()
	DB = Puffin.Component("Data") -- link to data management functions
	assert(DB, "Puffin.Model_Spells: invalid reference to data management component")
	DB.AllocateDatabase("spells", false)
	
	for k, p in pairs(runeSpells) do if p.id then p.name = GetSpellInfo(p.id); if p.name then localSpells[p.name] = k end end end
	for k, p in pairs(lockSpells[Puffin.myClass]) do if p.id then p.name = GetSpellInfo(p.id) end end

	DB.SetRedirect("spells", "runes", runeSpells)
	DB.SetRedirect("spells", "local", localSpells)
	DB.SetRedirect("spells", "locks", lockSpells[Puffin.myClass])
end

Puffin.RegisterComponent("Model_Spells", Model_Spells, "MODEL", 1)
